//Titel:        JTree
//Version:       1.0
//Copyright:     Copyright (c) 2003, 06
//Autor:         Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
//Organisation:  HS Harz
//Beschreibung:  Einführung in JTree


// Einfaches Beispiel mit DefaultMutableTreeNode
// CTreeNode liefert Zusatzinformationen
// es fehlt aber die Methode toString, siehe Tree06

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

import javax.swing.tree.DefaultMutableTreeNode;

import java.io.*;

import javax.swing.tree.*;

public class Tree05 extends JFrame {

  JTree jTree1;


  public Tree05() {
    setSize(400, 300);
    setTitle("JTree 5. Beispiel");
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
  }

  private void setGUI() {
    DefaultMutableTreeNode root;

    this.getContentPane().setLayout(  new BorderLayout()  );

    root = BuildTree();
    jTree1 = new javax.swing.JTree(root);
    jTree1.setFont( new Font("Arial", Font.BOLD,22)  );

    this.getContentPane().add( new JScrollPane(jTree1), BorderLayout.CENTER);

//    jTree1.getSelectionModel().setSelectionMode (TreeSelectionModel.SINGLE_TREE_SELECTION);

  } // setGUI


  // ----------------------------------------
  // BuildTree
  // ----------------------------------------
  DefaultMutableTreeNode BuildTree() {
    DefaultMutableTreeNode root;
    DefaultMutableTreeNode[]  Knoten = new DefaultMutableTreeNode[3];

    DefaultMutableTreeNode Kn0, Kn1, Kn2;

    root = new DefaultMutableTreeNode("root");

      // liefert einen DefaultMutableTreeNode
    Kn0 = createCNode(  1,  "1. Stufe");   // Daten und Bezeichnung
    root.add( Kn0 );

    Kn1 = createCNode(  2, "AAA");
    Kn0.add( Kn1 );
    Kn1 = createCNode(  3,  "BBB");
    Kn0.add( Kn1 );


    // ---------

    Kn0 = new DefaultMutableTreeNode("1. Stufe");
    root.add( Kn0 );

    Kn1 = new DefaultMutableTreeNode("CCC");
    Kn0.add( Kn1 );

    Kn1 = new DefaultMutableTreeNode("DDD");
    Kn0.add( Kn1 );

    return root;
  }  // BuildTree




  // erzeugt einen Knoten, verwendet eine zusaetzliche Klasse CTreeNode
  // CTreeNode liefert Zusatzinformationen
 DefaultMutableTreeNode createCNode(int CData,  String nodeString) {
    CTreeNode CNode;
    DefaultMutableTreeNode Node;

    CNode = new  CTreeNode(CData, nodeString);
    Node = new DefaultMutableTreeNode(CNode);
    //Node.setUserObject(CNode);
    return Node;
 }

 
  public static void main(String[] args) {
    Tree05 frame = new Tree05();
    frame.setVisible(true);
 }


}

// Einfache Klasse für jeden Knoten
class CTreeNode  {
  public static long nr=0;

    private long _id = 0; // Id des Knotens  z.B. als ID

    private int _CData;  // Daten

    public String _nodeString;  // Anzeige des Knoten


   public CTreeNode(int CData,  String nodeString) {
      _CData = CData;
      _nodeString = nodeString;  // für JTree;
      nr++;    // hochzaehlen
      _id = nr;  // setzt eindeutige Nummer, falss nodestring doppelt vorkommt
   }


   public long getID() {
     return _id;
   }

   public int getData() {
     return _CData;
   }

   public void setData(int CData) {
     _CData = CData;
   }
   

}  // CTreeNode


